#ifdef KERNEL
#include "../h/const.h"
#endif

/* Tables sizes */	/* Tune up NR_BUFS */
#define NR_ZONE_NUMS       9	/* # zone numbers in an inode */
#ifdef WANTLOCAL
# define NR_BUFS           60	/* # blocks in the buffer cache */
# define NR_BUF_HASH       64	/* size of buf hash table; MUST BE POWER OF 2*/
#else
#  ifdef BIGGER_BUF
#    ifdef WANT_HCJ_RS232
#      define NR_BUFS         32	/* # blocks in the buffer cache */
#    else
#      define NR_BUFS         60	/* # blocks in the buffer cache */
#    endif
#    define NR_BUF_HASH       32 /* size of buf hash table;MUST BE POWER OF 2*/
#  else
#    define NR_BUFS           20	/* # blocks in the buffer cache */
#    define NR_BUF_HASH       32 /* size of buf hash table;MUST BE POWER OF 2*/
#  endif
#endif
#define NR_FDS            20	/* max file descriptors per process */
#define NR_FILPS          64	/* # slots in filp table */
#define I_MAP_SLOTS        4	/* max # of blocks in the inode bit map */
#define ZMAP_SLOTS         6	/* max # of blocks in the zone bit map */
#define NR_INODES         32	/* # slots in "in core" inode table */
#define NR_SUPERS          5	/* # slots in super block table */
#define NAME_SIZE         14	/* # bytes in a directory component */
#ifdef i8088
#define FS_STACK_BYTES   512	/* size of file system stack */
#endif
#ifdef ATARI_ST
#define FS_STACK_BYTES  2048	/* size of file system stack */
#endif

/* Miscellaneous constants */
#define SUPER_MAGIC   0x137F	/* magic number contained in super-block */
#define SU_UID 	     (uid) 0	/* super_user's uid */
#define SYS_UID      (uid) 0	/* uid for processes MM and INIT */
#define SYS_GID      (gid) 0	/* gid for processes MM and INIT */
#define NORMAL	           0	/* forces get_block to do disk read */
#define NO_READ            1	/* prevents get_block from doing disk read */

#ifndef WANT_POOLE_FS
#define XPIPE  	           0	/* used in fp_task when suspended on pipe */
#else
#define XPIPE  -(NR_TASKS+1)	/* used in fp_task when suspended on pipe */
#define XOPEN  -(NR_TASKS+2)	/* used in fp_task when suspended in open */
#endif /* WANT_POOLE_FS */

#define NO_BIT    (bit_nr) 0	/* returned by alloc_bit() to signal failure */
#define DUP_MASK        0100	/* mask to distinguish dup2 from dup */

#define LOOK_UP            0	/* tells search_dir to lookup string */
#define ENTER              1	/* tells search_dir to make dir entry */
#define DELETE             2	/* tells search_dir to delete entry */

#define CLEAN              0	/* disk and memory copies identical */
#define DIRTY              1	/* disk and memory copies differ */

#define BOOT_BLOCK (block_nr) 0	/* block number of boot block */
#define SUPER_BLOCK (block_nr)1	/* block number of super block */
#define ROOT_INODE (inode_nr) 1	/* inode number for root directory */

/* Derived sizes */
#define ZONE_NUM_SIZE    ((int)sizeof(zone_nr))		/* # bytes in zone nr*/
#define NR_DZONE_NUM     (NR_ZONE_NUMS-2)		/* # zones in inode */
#define DIR_ENTRY_SIZE   ((int)sizeof(dir_struct))	/* # bytes/dir entry */
#define INODES_PER_BLOCK (BLOCK_SIZE/INODE_SIZE)	/* # inodes/disk blk */
#define INODE_SIZE       ((int)sizeof (d_inode))	/* bytes in disk inode*/
#define NR_DIR_ENTRIES   (BLOCK_SIZE/DIR_ENTRY_SIZE)	/* # dir entries/blk*/
#define NR_INDIRECTS     (BLOCK_SIZE/ZONE_NUM_SIZE)	/* # zones/indir blk */
#define INTS_PER_BLOCK   (BLOCK_SIZE/(int)sizeof(int))	/* # integers/blk */
#define SUPER_SIZE       ((int)sizeof(struct super_block)) /* super_block size */
#define PIPE_SIZE        (NR_DZONE_NUM*BLOCK_SIZE)	/* pipe size in bytes*/
#define MAX_ZONES (NR_DZONE_NUM+NR_INDIRECTS+(long)NR_INDIRECTS*NR_INDIRECTS)
						/* max # of zones in a file */
#ifdef KERNEL
#define printf printk

#ifdef __GNUC__
#define copy(dest, src, n) 	bcopy((src), (dest), (long)(n))
#define cmp_string(x, y, n)	(!(bcmp((x), (y), (long)(n))))

#define dup_inode(p)		((p)->i_count++)

#endif /* __GNUC__ */
#endif /* KERNEL */
