/*
 * vdi structure definitions and defines
 */

/* color indices */
#define	WHITE		0
#define	BLACK		1
#define	RED		2
#define	GREEN		3
#define	BLUE		4
#define	CYAN		5
#define	YELLOW		6
#define	MAGENTA		7
#define	LOW_WHITE	8
#define	GREY		9
#define	LIGHT_RED	10
#define LIGHT_GREEN	11
#define	LIGHT_BLUE	12
#define	LIGHT_CYAN	13
#define	LIGHT_YELLOW	14
#define	LIGHT_MAGENTA	15

/* writing modes */
#define	WR_REPLACE	1
#define	WR_TRANSPARENT	2
#define	WR_XOR		3
#define	WR_REVTRANS	4

/* end styles */
#define SQUARE_ESTYLE	0	/* default */

/* line types */
#define SOLID_LTYPE	1
#define LONG_DASH_LTYPE	2
#define DOT_LTYPE	3
#define DASHDOT_LTYPE	4
#define DASH_LTYPE	5
#define	DASHDOTDOT_LTYPE 6
#define USERDEF_LTYPE	7

/* fill interior styles */
#define HOLLOW_IS	0
#define SOLID_IS	1
#define PATTERN_IS	2
#define HATCH_IS	3
#define USERDEF_IS	4

/* raster copy modes */
#define	ALL_ZEROS	0
#define S_AND_D		1
#define	S_AND_NOTD	2
#define S_ONLY		3
#define NOTS_AND_D	4
#define NOCHANGE	5
#define	S_XOR_D		6
#define	S_OR_D		7
#define NOTS_AND_NOTD	8
#define NOTS_XOR_NOTD	9
#define NOT_D		10
#define S_OR_NOTD	11
#define NOT_S		12
#define NOTS_OR_D	13
#define NOTS_OR_NOTD	14
#define ALL_ONES	15

struct vdi_opin { 	/* used in v_opnvwk */
	unsigned short	coordmode, linetype, linecolor, marktype, markcolor,
			textfont, textcolor, fillstyle, fillcolor, promptflag;
};

struct	vdi_opout {	/* used in v_opnvwk */
	short	maxx, maxy, devcoord, pelwidth, pelheight, numcharhght,
		numlinetyp, numlinewid, nummarktyp, nummarksiz, numgfonts,
		numpatterns, numhatch, numcolors, numgdp, gdplist[10],
		gdpattr[10], doescolor, rotstext, canfill, pixelops,
		locateflg, valuatflg, choiceflg, stringflg, stationtyp,
		devicetyp, numwrite, inputlevel, alignstext, inkingflg,
		rubberband, maxndcx, maxndcy, version[5];
};

struct	vdi_lattr {	/* used in vql_attributes */
	short	linetyp, linecolor, linemode, beginstyle, endstyle, linewid;
};

struct	vdi_fattr {	/* used in vqf_attributes */
	short	insidestyle, color, style, wrmode, perimeter;
};

struct	vdi_tattr { 	/* used in vqt_attributes */
	short	textface, color, angle, halign, valign, wrmode,
		charwid, charhgt, charcellw, charcellh;
};

struct mfdb {	/* memory form definition block */
	char *fd_addr;
	short fd_w, fd_h, fd_wdwidth, fd_stand, fd_nplanes;
};

#if __STDC__ == 1

extern v_bar(int h, const int xy[]);
extern v_clrwk(int h);
extern v_clsvwk(int h);
extern v_curtext(int h, const char* s);
extern v_enter_cur(int h);
extern v_exit_cur(int h);
extern v_fillarea(int h, int count, const int* xy);
extern v_hide_c(int h);
extern v_opnvwk(struct vdi_opin *work_in, int* h, struct vdi_opout * work_out);
extern v_pline(int h, int count, const int* xy);
extern v_rvoff(int h);
extern v_rvon(int h);
extern v_show_c(int h, int reset);
extern vqf_attributes(int h, struct vdi_fattr *attr_p);
extern vql_attributes(int h, struct vdi_lattr *attr_p);
extern vqt_attributes(int h, struct vdi_tattr *attr_p);
extern vr_recfl(int h, int* xy);
extern vro_cpyfm(int h, int m, const int* xy, struct mfdb *s, struct mfdb *d);
extern vs_clip(int h, int clip_flag, int* xy);
extern vs_curaddress(int h, int r, int c);
extern vsf_color(int h, int color);
extern vsf_interior(int h, int style);
extern vsf_perimeter(int h, int flag);
extern vsf_style(int h, int index);
extern vsl_color(int h, int color);
extern vsl_type(int h, int type);
extern vswr_mode(int h, int mode);

#endif
