/* The <minix.h> header is the master header used by the operating system
 * (kernel, FS, and MM).  All the C files in these three directories include
 * <minix.h>.  It defines a few key symbols and includes headers that just
 * about all the routines need.  Note that the symbols _FS, _MM, and _KERNEL
 * are defined in the respective makefiles.
 */

/* First come the defines. */
#define _POSIX_SOURCE      1	/* tell headers to include POSIX stuff */
#define _MINIX             1	/* tell headers to include MINIX stuff */
#define _SYSTEM            1	/* tell headers that this is the kernel */

/* The following are so basic, all the *.c files get them automatically. */
#include <minix/config.h>	/* must be first */
#include <sys/types.h>
#include <limits.h>
#include <errno.h>

#include <minix/const.h>
#include <minix/type.h>

#if 0
/* this is bullshit, absolute pathnames! who taught these people programming */
#ifdef _KERNEL
#include "/usr/src/kernel/const.h"
#include "/usr/src/kernel/type.h"
#include "/usr/src/kernel/proto.h"
#include "/usr/src/kernel/glo.h"
#endif

#ifdef _FS
#include "/usr/src/fs/const.h"
#include "/usr/src/fs/type.h"
#include "/usr/src/fs/proto.h"
#include "/usr/src/fs/glo.h"
#endif

#ifdef _MM
#include "/usr/src/mm/const.h"
#include "/usr/src/mm/type.h"
#include "/usr/src/mm/proto.h"
#include "/usr/src/mm/glo.h"
#endif

#endif
