#ifdef NO_POOLE_FS
#  ifdef WANT_POOLE_FS
#    undef WANT_POOLE_FS
#  endif
#else
#  ifndef WANT_POOLE_FS
#    define WANT_POOLE_FS
#  endif
#endif

#ifdef WANT_POOLE_FS
/* fcntl.h for modified minix fs */
#ifndef KERNEL
#include <std.h>
#endif

/* For fcntl(2)  */

#define     F_DUPFD	0		/* DUP */
#define     F_GETFD	1		/* get close-on-exec flag */
#define     F_SETFD	2		/* set close-on-exec flag */
#define     F_GETFL	3		/* get file status flags */
#define     F_SETFL	4		/* set file status flags */

/* For open(2) only */

#define     O_RDONLY	000000
#define     O_WRONLY	000001
#define     O_RDWR	000002

/* For open and fcntl */
#define     O_NONBLOCK  000004
#define     O_APPEND    000010
#define     O_CREAT     001000
#define     O_TRUNC     002000
#define	    O_EXCL	004000
#ifdef KERNEL
#define	    O_FIRSTOPEN 010000
#define	    O_LASTCLOSE 020000
#endif

/* other names, for convienience */
#define FNDELAY		O_NONBLOCK	/* BSD */
#define O_NDELAY	O_NONBLOCK	/* SysV */
#define FAPPEND		O_APPEND	/* BSD */
#define FTRUNC		O_TRUNC		/* BSD */
#define FCREAT		O_CREAT		/* BSD */
#define FEXCL		O_EXCL		/* BSD */


/* used in fs */
#define     O_LEGAL (O_WRONLY|O_RDWR|O_NONBLOCK|O_APPEND|O_CREAT|O_TRUNC|O_EXCL)
#define     F_FL_LEGAL	(O_NONBLOCK|O_APPEND)

#endif /* WANT_POOLE_FS */
