#ifdef NO_POOLE_FS
#  ifdef WANT_POOLE_FS
#    undef WANT_POOLE_FS
#  endif
#else
#  ifndef WANT_POOLE_FS
#    define WANT_POOLE_FS
#  endif
#endif

struct stat {
    short int st_dev;
    unsigned short st_ino;
    unsigned short st_mode;
    short int st_nlink;
    short int st_uid;
    short int st_gid;
    short int st_rdev;
    long st_size;
    long st_atime;
    long st_mtime;
    long st_ctime;
};

/* Some common definitions. */
#define S_IFMT  0170000		/* type of file */
#define S_IFDIR 0040000  	/* directory */
#define S_IFCHR 0020000		/* character special */
#define S_IFBLK 0060000		/* block special */
#define S_IFREG 0100000		/* regular */
#ifndef WANT_POOLE_FS
#define S_ISUID   04000		/* set user id on execution */
#define S_ISGID   02000		/* set group id on execution */
#else
#define S_IFIFO 0010000		/* named pipe (FIFO) */
/* #define S_IFLNK	0120000 */	/* symbolic link */
#define S_ISUID   04000		/* set user id on execution (POSIX) */
#define S_ISGID   02000		/* set group id on execution (POSIX) */
#endif /* WANT_POOLE_FS */
#define S_ISVTX   01000		/* save swapped text even after use */
#define S_IREAD   00400		/* read permission, owner */
#define S_IWRITE  00200		/* write permission, owner */
#define S_IEXEC   00100		/* execute/search permission, owner */

#ifdef WANT_POOLE_FS

/* POSIX defines */
#define S_IRWXU	  00700		/* owner rwx */
#define S_IRUSR   00400		/* owner r   */
#define S_IWUSR   00200		/* owner  w  */
#define S_IXUSR   00100		/* owner   x */
#define S_IRWXG	  00070		/* group rwx */
#define S_IRGRP   00040		/* group r   */
#define S_IWGRP   00020		/* group  w  */
#define S_IXGRP   00010		/* group   x */
#define S_IRWXO	  00007		/* other rwx */
#define S_IROTH   00004		/* other r   */
#define S_IWOTH   00002		/* other  w  */
#define S_IXOTH   00001		/* other   x */

/* POSIX macros */
#define S_ISDIR(m)	(S_IFDIR & (m))		/* directory? */
#define S_ISCHR(m)	(S_IFCHR & (m))		/* character special? */
#define S_ISBLK(m)	(S_IFBLK & (m))		/* block special? */
#define S_ISREG(m)	(S_IFREG & (m))		/* regular file? */
#define S_ISFIFO(m)	(S_IFFIFO & (m))	/* fifo? */

/* compatibilty with ? */
#define S_IPIPE S_IFIFO

#endif /* WANT_POOLE_FS */
