/*
 * stboots.h
 *	common include file describes the atariSt media boot sector
 *	and partitions
 *  ++jrb	bammi@dsrgsun.ces.cwru.edu
 */

/*
 * Block 0 of a TOS media	-- from tos.c
 *	(media : floppy diskette or hard disk partion)
 * boot sector parameter block
 * returned by DKGETP (see sgtty.h)
 *	word parameters are in little endian byte order (808x order).
 */

struct block0 {
/*   0 */    unsigned char b0_bras[2];	 /* branch code to boot code 	*/
/*   2 */    unsigned char b0_oem [6];	 /* reserved for OEM use	*/
/*   8 */    unsigned char b0_serial[3]; /* 24 bit serial number 	*/
/*  11 */    unsigned char b0_bps[2];	 /* byte/sector			*/
/*  13 */    unsigned char b0_spc;	 /* sectors/cluster		*/
/*  14 */    unsigned char b0_res[2];	 /* number or reserved sectors	*/
/*  16 */    unsigned char b0_nfats;	 /* number of FATS 		*/
/*  17 */    unsigned char b0_ndirs[2];	 /* number of dir entries 	*/
/*  19 */    unsigned char b0_nsects[2]; /* number of sectors on media	*/
/*  21 */    unsigned char b0_media;	 /* media descriptor (not used)	*/
/*  22 */    unsigned char b0_spf[2];	 /* sectors/FAT			*/
/*  24 */    unsigned char b0_spt[2];	 /* sectors/track		*/
/*  26 */    unsigned char b0_nsides[2]; /* number of sides		*/
/*  28 */    unsigned char b0_nhid[2];	 /* number of hidden sectors(nu)*/
/*  30 */    unsigned char b0_code[480]; /* boot code 			*/
/* 510 */    unsigned char b0_cksm[2];	 /* even out chksum to 0x1234 	*/
};

/* partition info for hard disks */

/* values of pi_flag: */
#define	PI_INVALID	0x00
#define	PI_BOOT		0x80

struct pi {
  char	pi_flag;		/* active byte */
  char	pi_id[3];		/* partition id (GEM or MIX(?)) */
  long	pi_start;		/* first sector */
  long	pi_size;		/* total number of sectors */
};

/* 
 * structure returned by
 *	ioctl(<n>, DKPART, struct part *)
 */
struct part {
    struct pi	hd_pi[16];	/* partition descriptors for upto 16 */
				/* possible partions on the hard disk. */
				/* Note:
				   0 is not really a partition
				   1-4	regular partitions
				   5	whole physical disk
				   6-7  not used
				   8-15 8 extended supra partitions
				        these have meaningful values
					only if kernel/stwini was
					compiled with SUPRA_PART
				*/
    				/* all unused partitions will have 
				   pi_flag == PI_INVALID and
				   pi_size == 0
				 */
};

