#ifndef _PTRACE_H
#define _PTRACE_H

/*
 * <sys/ptrace.h>
 *	to go with minix-st ptrace(2) by bds@lzaz.ATT.COM (B.SZABLAK)
 *	++jrb
 */

typedef int ptracereq;			/* for bsd software portabilty */

/*
 * Request values for the ptrace system call
 */
#define PTRACE_TRACEME		0	/* by tracee to begin tracing */
#define PTRACE_CHILDDONE	0	/* tracee is done with his half */
#define PTRACE_PEEKTEXT		1	/* read word from text segment */
#define PTRACE_PEEKDATA		2	/* read word from data segment */
#define PTRACE_PEEKUSER		3	/* read word from user struct */
#define PTRACE_POKETEXT		4	/* write word into text segment */
#define PTRACE_POKEDATA		5	/* write word into data segment */
#define PTRACE_POKEUSER		6	/* write word into user struct */
#define PTRACE_CONT		7	/* continue process */
#define PTRACE_KILL		8	/* terminate process */
#define PTRACE_SINGLESTEP	9	/* single step process */

#endif /* _PTRACE_H */
